/** \file src/xtal/xtal_debug.h
* \brief src/xtal/xtal_debug.h
*/

#ifndef XTAL_DEBUG_H_INCLUDE_GUARD
#define XTAL_DEBUG_H_INCLUDE_GUARD

#pragma once

namespace xtal{

/**
* \xbind lib::builtin
* \brief fobO
*/
namespace debug{

class CallerInfo : public Base{
public:

	/**
	* \xbind
	* \brief Ăяoꏊ̍sԂ
	*/
	int_t lineno(){ return line_; }

	const MethodPtr& fun(){ return fun_; }

	/**
	* \xbind
	* \brief Ăяoꏊ̃t@CԂ
	*/
	StringPtr file_name();

	/**
	* \xbind
	* \brief Ăяoꏊ̊֐Ԃ
	*/
	StringPtr fun_name();

	/**
	* \xbind
	* \brief Ăяoꏊ̕ϐt[IuWFNgԂ
	*/
	const FramePtr& variables_frame(){ return variables_frame_; }

	void set_line(int_t v){ line_ = v; }
	void set_fun(const MethodPtr& v){ fun_ = v; }
	void set_variables_frame(const FramePtr& v){ variables_frame_ = v; }

	void on_visit_members(Visitor& m);

private:
	int_t line_;
	MethodPtr fun_;
	FramePtr variables_frame_;
};

typedef SmartPtr<CallerInfo> CallerInfoPtr;

/**
* \xbind lib::builtin::debug
* \xinherit lib::builtin::Any
* \brief fobOtbN֐œnIuWFNg
*/
class HookInfo : public Base{
public:
	
	/**
	* \xbind
	* \brief tbN̎ނԂ
	*/
	int_t kind(){ return kind_; } 

	/**
	* \xbind
	* \brief tbNꂽꏊ̍sԂ
	*/
	int_t lineno(){ return line_; }

	/**
	* \xbind
	* \brief tbNꂽꏊCodeIuWFNgԂ
	*/
	const CodePtr& code(){ return code_; }

	/**
	* \xbind
	* \brief tbNꂽꏊ̃t@CԂ
	*/
	const StringPtr& file_name(){ return file_name_; }

	/**
	* \xbind
	* \brief tbNꂽꏊ̊֐Ԃ
	*/
	const StringPtr& fun_name(){ return fun_name_; }

	/**
	* \xbind
	* \brief OIuWFNgԂ
	*/
	const AnyPtr& exception(){ return exception_; }

	/**
	* \xbind
	* \brief tbNꂽꏊ̕ϐt[IuWFNgԂ
	*/
	const FramePtr& variables_frame(){ return variables_frame_; }

	/**
	* \brief ĂяȍԂ
	*/
	CallerInfoPtr caller(uint_t n);

	int_t call_stack_size();

	void set_kind(int_t v){ kind_ = v; }
	void set_line(int_t v){ line_ = v; }
	void set_code(const CodePtr& v){ code_ = v; }
	void set_file_name(const StringPtr& v){ file_name_ = v; }
	void set_fun_name(const StringPtr& v){ fun_name_ = v; }
	void set_exception(const AnyPtr& e){ exception_ = e; }
	void set_variables_frame(const FramePtr& v){ variables_frame_ = v; }

	/**
	* \xbind
	* \brief N[
	* HookInfoIuWFNg͎g܂킳邽߁AێꍇAN[KvB
	*/
	SmartPtr<HookInfo> clone();

	void set_vm(const VMachinePtr& v);

	const VMachinePtr& vm();

	void on_visit_members(Visitor& m);

private:

	int_t kind_;
	int_t line_;
	CodePtr code_;
	StringPtr file_name_;
	StringPtr fun_name_;
	AnyPtr exception_;
	FramePtr variables_frame_;
	VMachine* vm_;

	friend class VMachine;
};

typedef SmartPtr<HookInfo> HookInfoPtr;

class Debug{};

/**
* \xbind lib::builtin::debug
* \brief fobO@\Lɂ
* fobO@\̓ftHgł͖ɂȂĂB
*/
void enable();

/**
* \xbind lib::builtin::debug
* \brief fobO@\𖳌ɂ
*/
void disable();

/**
* \xbind lib::builtin::debug
* \brief fobO@\IɗLɂ
* fobO@\̓ftHgł͖ɂȂĂB
*/
void enable_force(uint_t count);

/**
* \xbind lib::builtin::debug
* \brief fobO@\Iɖɂ
*/
uint_t disable_force();

/**
* \xbind lib::builtin::debug
* \brief fobO@\Lǂ
*/
bool is_enabled();

uint_t hook_setting_bit();

uint_t* hook_setting_bit_ptr();

void set_hook(int_t hooktype, const AnyPtr& hook);

const AnyPtr& hook(int_t hooktype);

/**
* \xbind lib::builtin::debug
* \brief u[N|CgɒB邽тɌĂяotbN֐o^
* \param hook o^tbN֐
*/
void set_breakpoint_hook(const AnyPtr& hook);

/**
* \xbind lib::builtin::debug
* \brief ֐ĂяoxɌĂяotbN֐o^
* \param hook o^tbN֐
*/
void set_call_hook(const AnyPtr& hook);

/**
* \xbind lib::builtin::debug
* \brief ֐returnxɌĂяotbN֐o^
* \param hook o^tbN֐
*/
void set_return_hook(const AnyPtr& hook);

/**
* \xbind lib::builtin::debug
* \brief OthrowxɌĂяotbN֐o^
* \param hook o^tbN֐
*/
void set_throw_hook(const AnyPtr& hook);

/**
* \xbind lib::builtin::debug
* \brief AT[gsxɌĂяotbN֐o^
* \param hook o^tbN֐
*/
void set_assert_hook(const AnyPtr& hook);

/**
* \xbind lib::builtin::debug
* \brief set_breakpoint_hook֐œo^֐擾
*/
const AnyPtr& breakpoint_hook();

/**
* \xbind lib::builtin::debug
* \brief set_call_hook֐œo^֐擾
*/
const AnyPtr& call_hook();

/**
* \xbind lib::builtin::debug
* \brief set_return_hook֐œo^֐擾
*/
const AnyPtr& return_hook();

/**
* \xbind lib::builtin::debug
* \brief set_throw_hook֐œo^֐擾
*/
const AnyPtr& throw_hook();

/**
* \xbind lib::builtin::debug
* \brief set_assert_hook֐œo^֐擾
*/
const AnyPtr& assert_hook();


//////////////////////////////

enum{
	RUN,
	STEP_OVER,
	STEP_INTO,
	STEP_OUT,
	REDO
};

void call_breakpoint_hook(int_t kind, const HookInfoPtr& info);

}

}

#endif // XTAL_DEBUG_H_INCLUDE_GUARD
